## znc 1.8.2

=== CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.1)
project(ZNC VERSION 1.8.2 LANGUAGES CXX)
set(ZNC_VERSION 1.8.2)
set(append_git_version false)
set(alpha_version "") # e.g. "-rc1"
set(VERSION_EXTRA "" CACHE STRING
	"Additional string appended to version, e.g. to mark distribution")

set(PROJECT_VERSION "${ZNC_VERSION}")

# https://cmake.org/pipermail/cmake/2010-September/039388.html
set(_all_targets "" CACHE INTERNAL "")
function(znc_add_library name)
	add_library("${name}" ${ARGN})
	set(_all_targets "${_all_targets};${name}" CACHE INTERNAL "")
endfunction()
function(znc_add_executable name)
	add_executable("${name}" ${ARGN})
	set(_all_targets "${_all_targets};${name}" CACHE INTERNAL "")
endfunction()
function(znc_add_custom_target name)
	add_custom_target("${name}" ${ARGN})
	set(_all_targets "${_all_targets};${name}" CACHE INTERNAL "")
endfunction()

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(TestCXX11)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED true)
if(NOT CYGWIN)
	# We don't want to use -std=gnu++11 instead of -std=c++11, but among other
	# things, -std=c++11 on cygwin defines __STRICT_ANSI__ which makes cygwin
	# not to compile: undefined references to strerror_r, to fdopen, to
	# strcasecmp, etc (their declarations in system headers are between ifdef)
	set(CMAKE_CXX_EXTENSIONS false)
endif()

include(CMakeFindFrameworks_fixed)
include(use_homebrew)
include(GNUInstallDirs)
include(CheckCXXSymbolExists)
include(copy_csocket)

set(CMAKE_THREAD_PREFER_PTHREAD true)
set(THREADS_PREFER_PTHREAD_FLAG true)
find_package(Threads REQUIRED)
if(NOT CMAKE_USE_PTHREADS_INIT)
	message(FATAL_ERROR "This compiler/OS doesn't seem to support pthreads.")
endif()

include(TestLargeFiles)
test_large_files(HAVE_LARGE_FILES_UNUSED_VAR)
find_package(PkgConfig)

macro(tristate_option opt help)
	set(WANT_${opt} AUTO CACHE STRING ${help})
	set_property(CACHE WANT_${opt} PROPERTY STRINGS AUTO YES NO)
	if(WANT_${opt} STREQUAL "AUTO")
		set(TRISTATE_${opt}_REQUIRED)
	else()
		set(TRISTATE_${opt}_REQUIRED REQUIRED)
	endif()
endmacro()

tristate_option(OPENSSL "Support SSL")
if(WANT_OPENSSL)
	find_package(OpenSSL ${TRISTATE_OPENSSL_REQUIRED})
endif()
set(HAVE_LIBSSL "${OPENSSL_FOUND}")

set(WANT_IPV6 true CACHE BOOL "Support IPv6")
set(HAVE_IPV6 "${WANT_IPV6}")

tristate_option(ZLIB "Compress HTTP traffic with Zlib")
if(WANT_ZLIB)
	find_package(ZLIB ${TRISTATE_ZLIB_REQUIRED})
endif()
set(HAVE_ZLIB "${ZLIB_FOUND}")

tristate_option(CYRUS "Support authentication with Cyrus")
if(WANT_CYRUS)
	pkg_check_modules(CYRUS libsasl2)
	if(NOT CYRUS_FOUND)
		# libsasl2.pc is missing on 2.1.25 which is on ubuntu 14.04
		# next ubuntu version has 2.1.26 which has libsasl2.pc
		#
		# osx (as of El Capitan) doesn't have it either...
		set(_old_cmake_required_libraries "${CMAKE_REQUIRED_LIBRARIES}")
		set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} -lsasl2)
		# sys/types.h here is workaround for sasl 2.1.26:
		# https://github.com/znc/znc/issues/1243
		# https://lists.andrew.cmu.edu/pipermail/cyrus-sasl/2012-December/002572.html
		# https://cgit.cyrus.foundation/cyrus-sasl/commit/include/sasl.h?id=2f740223fa1820dd71e6ab0e50d4964760789209
		check_cxx_symbol_exists(sasl_server_init "sys/types.h;sasl/sasl.h"
			CYRUS_HARDCODED)
		set(CMAKE_REQUIRED_LIBRARIES "${_old_cmake_required_libraries}")
		if(CYRUS_HARDCODED)
			set(CYRUS_LDFLAGS -lsasl2)
			set(CYRUS_FOUND true)
		endif()
	endif()
	if(TRISTATE_CYRUS_REQUIRED AND NOT CYRUS_FOUND)
		message(FATAL_ERROR "Can't find Cyrus SASL 2")
	endif()
endif()

tristate_option(ICU "Support character encodings")
if(WANT_ICU)
	pkg_check_modules(ICU ${TRISTATE_ICU_REQUIRED} icu-uc)
endif()
set(HAVE_ICU "${ICU_FOUND}")

set(WANT_PERL false CACHE BOOL "Support Perl modules")
set(WANT_PYTHON false CACHE BOOL "Support Python modules")
set(WANT_PYTHON_VERSION "python3" CACHE STRING
	"Python version to use, e.g. python-3.5, this name is passed to pkg-config")
if(WANT_PYTHON AND NOT ICU_FOUND)
	message(FATAL_ERROR "Modpython requires ZNC to be compiled with charset "
	"support, but ICU library not found")
endif()
tristate_option(SWIG "Use SWIG to generate modperl and modpython")
set(search_swig false)
if(WANT_SWIG AND TRISTATE_SWIG_REQUIRED)
	set(search_swig true)
endif()
if(WANT_PERL AND NOT EXISTS
		"${PROJECT_SOURCE_DIR}/modules/modperl/generated.tar.gz")
	if(WANT_SWIG)
		set(search_swig true)
	else()
		message(FATAL_ERROR "Pregenerated modperl files are not available. "
			"SWIG is required. Alternatively, build ZNC from tarball.")
	endif()
endif()
if(WANT_PYTHON AND NOT EXISTS
		"${PROJECT_SOURCE_DIR}/modules/modpython/generated.tar.gz")
	if(WANT_SWIG)
		set(search_swig true)
	else()
		message(FATAL_ERROR "Pregenerated modpython files are not available. "
			"SWIG is required. Alternatively, build ZNC from tarball.")
	endif()
endif()
if(search_swig)
	find_package(SWIG 3.0.0)
	if(NOT SWIG_FOUND)
		message(FATAL_ERROR
			"Can't find SWIG, therefore Perl and Python aren't supported. "
			"Alternatively, build ZNC from tarball.")
	endif()
endif()

if(WANT_PERL)
	find_package(PerlLibs 5.10 REQUIRED)
endif()
if (WANT_PYTHON)
	find_package(Perl 5.10 REQUIRED)
	# VERSION_GREATER_EQUAL is available only since 3.7
	if (CMAKE_VERSION VERSION_LESS 3.12)
	else()
		# Even if FindPython3 is available (since CMake 3.12) we still use
		# pkg-config, because FindPython has a hardcoded list of python
		# versions, which may become outdated when new pythons are released,
		# but when cmake in the distro is old.
		#
		# Why FindPython3 is useful at all? Because sometimes there is no
		# python3.pc, but only python-3.5.pc and python-3.6.pc; which would
		# force user to provide the version explicitly via
		# WANT_PYTHON_VERSION. This is the case on Gentoo when NOT building
		# via emerge.
		if (WANT_PYTHON_VERSION STREQUAL "python3")
			find_package(Python3 COMPONENTS Development)
		else()
			# We used to pass value like "python-3.5" to the variable.
			if (WANT_PYTHON_VERSION MATCHES "^(python-)?(.*)$")
				find_package(Python3 COMPONENTS Development
					EXACT "${CMAKE_MATCH_2}")
			else()
				message(FATAL_ERROR "Invalid value of WANT_PYTHON_VERSION")
			endif()
		endif()
		if (Python3_FOUND AND Python3_VERSION VERSION_LESS 3.3)
			message(STATUS "Python too old, need at least 3.3")
			set(Python3_FOUND OFF)
		else()
			# Compatibility with pkg-config variables
			set(Python3_LDFLAGS "${Python3_LIBRARIES}")
		endif()
	endif()
	if (NOT Python3_FOUND AND WANT_PYTHON_VERSION MATCHES "^python")
		# Since python 3.8, -embed is required for embedding.
		pkg_check_modules(Python3 "${WANT_PYTHON_VERSION}-embed >= 3.3")
		if (NOT Python3_FOUND)
			pkg_check_modules(Python3 "${WANT_PYTHON_VERSION} >= 3.3")
		endif()
	endif()
	if (NOT Python3_FOUND)
		message(FATAL_ERROR "Python 3 is not found. Try disabling it.")
	endif()
endif()

set(WANT_TCL false CACHE BOOL "Support Tcl modules")
if(WANT_TCL)
	find_package(TCL QUIET)
	if(NOT TCL_FOUND)
		message(FATAL_ERROR "Can't find Tcl")
	endif()
endif()

tristate_option(I18N "Native language support (i18n)")
if(WANT_I18N)
	find_package(Boost ${TRISTATE_I18N_REQUIRED} COMPONENTS locale)
	find_package(Gettext ${TRISTATE_I18N_REQUIRED})
endif()
if(Boost_LOCALE_FOUND AND GETTEXT_MSGFMT_EXECUTABLE)
	set(HAVE_I18N true)
else()
	set(HAVE_I18N false)
	message(STATUS "Boost.Locale or gettext (msgfmt) is not found, disabling i18n support")
endif()

if(HAVE_I18N AND GETTEXT_MSGMERGE_EXECUTABLE)
	find_program(XGETTEXT_EXECUTABLE xgettext)
	if(XGETTEXT_EXECUTABLE)
		add_custom_target(translation)
	endif()
endif()

# poll() is broken on Mac OS, it fails with POLLNVAL for pipe()s.
if(APPLE)
	set(CSOCK_USE_POLL false)
else()
	set(CSOCK_USE_POLL true)
endif()

check_cxx_symbol_exists(getopt_long "getopt.h" HAVE_GETOPT_LONG)
check_cxx_symbol_exists(lstat "sys/types.h;sys/stat.h;unistd.h" HAVE_LSTAT)
check_cxx_symbol_exists(getpassphrase "stdlib.h" HAVE_GETPASSPHRASE)
check_cxx_symbol_exists(tcsetattr "termios.h;unistd.h" HAVE_TCSETATTR)
check_cxx_symbol_exists(clock_gettime "time.h" HAVE_CLOCK_GETTIME)

# Note that old broken systems, such as OpenBSD, NetBSD, which don't support
# AI_ADDRCONFIG, also have thread-unsafe getaddrinfo(). Gladly, they fixed
# thread-safety before support of AI_ADDRCONFIG, so this can be abused to
# detect the thread-safe getaddrinfo().
#
# TODO: drop support of blocking DNS at some point. OpenBSD supports
# AI_ADDRCONFIG since Nov 2014, and their getaddrinfo() is thread-safe since
# Nov 2013. NetBSD's one is thread-safe since ages ago.
check_cxx_symbol_exists(AI_ADDRCONFIG "sys/types.h;sys/socket.h;netdb.h"
	HAVE_THREADED_DNS)

if(CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT CYGWIN)
	# These enable some debug options in g++'s STL, e.g. invalid use of
	# iterators, but they cause crashes on cygwin while loading modules
	set(_GLIBCXX_DEBUG true)
	set(_GLIBCXX_DEBUG_PEDANTIC true)
endif()

if(append_git_version)
	find_package(Git)
endif()



file(GLOB csocket_files LIST_DIRECTORIES FALSE
	"${PROJECT_SOURCE_DIR}/third_party/Csocket/Csocket.*")
if(csocket_files STREQUAL "")
	execute_process(COMMAND git status
		WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
		RESULT_VARIABLE git_status_var
		OUTPUT_QUIET
		ERROR_QUIET)
	if(git_status_var)
		message(FATAL_ERROR
			" It looks like git submodules are not initialized.\n"
			" Either this is not a git clone, or you don't have git installed.\n"
			" Fetch the tarball from the website: https://znc.in/releases/ ")
	else()
		message(FATAL_ERROR
			" It looks like git submodules are not initialized.\n"
			" Run: git submodule update --init --recursive")
	endif()
endif()

install(DIRECTORY webskins
	DESTINATION "${CMAKE_INSTALL_DATADIR}/znc")
install(DIRECTORY translations
	DESTINATION "${CMAKE_INSTALL_DATADIR}/znc")
install(DIRECTORY man/
	DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
	FILES_MATCHING PATTERN "znc*")

set(WANT_SYSTEMD false CACHE BOOL "Install znc.service to systemd")
if(WANT_SYSTEMD)
	configure_file("znc.service.in" "znc.service")
	set(SYSTEMD_DIR "" CACHE PATH "Path to systemd units")
	if(SYSTEMD_DIR STREQUAL "" AND PKG_CONFIG_EXECUTABLE)
		execute_process(COMMAND "${PKG_CONFIG_EXECUTABLE}"
			--variable=systemdsystemunitdir systemd
			OUTPUT_VARIABLE SYSTEMD_DIR)
	endif()
	if(SYSTEMD_DIR STREQUAL "")
		message(FATAL_ERROR "Systemd is enabled, "
			"but the unit dir can't be found.")
	endif()
	install(FILES "${PROJECT_BINARY_DIR}/znc.service"
		DESTINATION "${SYSTEMD_DIR}")
endif()

# On cygwin, if to link modules against znc.exe directly, modperl can't call
# ZNC's functions very well. They do get called, but global variables have
# different addresses. That address actually is in modperl/ZNC.dll if to look
# at /proc/123/maps
# Example of such global variable is one returned by CZNC::Get()
# Modpython seems to work though with STATIC on cygwin... (I didn't test it
# too much though)
#
# Non-cygwin should link modules to /usr/bin/znc directly to prevent this:
# error while loading shared libraries: libznc.so: cannot open shared object file: No such file or directory
# Without need to touch LD_LIBRARY_PATH
if(CYGWIN)
	set(znc_link "znclib")
	set(lib_type "SHARED")
	set(install_lib "znclib")
	set(znclib_pc "-L${CMAKE_INSTALL_FULL_LIBDIR} -lznc")
else()
	set(znc_link "znc")
	set(lib_type "STATIC")
	set(install_lib)
	set(znclib_pc)
endif()

=== include/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

add_subdirectory(znc)

=== modules/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# This is not recommended, but whatever.
file(GLOB all_modules LIST_DIRECTORIES FALSE "*")

function(add_cxx_module mod modpath)
	znc_add_library("module_${mod}" MODULE "${modpath}")
	set_target_properties("module_${mod}" PROPERTIES
		OUTPUT_NAME "${mod}"
		PREFIX ""
		SUFFIX ".so"
		NO_SONAME true
		CXX_VISIBILITY_PRESET "hidden")
	if(moddef_${mod})
		target_compile_definitions("module_${mod}" ${moddef_${mod}})
	endif()
	if(modcompile_${mod})
		target_compile_options("module_${mod}" ${modcompile_${mod}})
	endif()
	if(modinclude_${mod})
		target_include_directories("module_${mod}" ${modinclude_${mod}})
	endif()
	if(moddepend_${mod})
		add_dependencies("module_${mod}" ${moddepend_${mod}})
	endif()
	# ${znclib_LIB_DEPENDS} is to overcome OSX's need for -undefined suppress
	# when accessing symbols exported by dependencies of znclib (e.g.
	# openssl), but not used in znclib itself
	target_link_libraries("module_${mod}" PRIVATE ZNC ${modlink_${mod}}
		${znclib_LIB_DEPENDS})
	set_target_properties("module_${mod}" PROPERTIES "" "" ${modprop_${mod}})
	install(TARGETS "module_${mod}"
		LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/znc")
endfunction()

function(add_perl_module mod modpath)
endfunction()

function(add_python_module mod modpath)
endfunction()

if(CYRUS_FOUND)
	set(modcompile_cyrusauth PRIVATE ${CYRUS_CFLAGS})
	set(modlink_cyrusauth ${CYRUS_LDFLAGS})
else()
	set(moddisable_cyrusauth true)
endif()

if(PERLLIBS_FOUND)
	add_subdirectory(modperl)
else()
	set(moddisable_modperl true)
endif()

if(Python3_FOUND)
	add_subdirectory(modpython)
else()
	set(moddisable_modpython true)
endif()

if(TCL_FOUND)
	add_subdirectory(modtcl)
else()
	set(moddisable_modtcl true)
endif()

set(actual_modules)

foreach(modpath ${all_modules})
	if(NOT "${modpath}" MATCHES "/([-a-zA-Z0-9_]+)\\.([a-z]+)$")
		continue()
	endif()
	set(mod "${CMAKE_MATCH_1}")
	set(modtype "${CMAKE_MATCH_2}")
	if(mod STREQUAL "CMakeLists" OR mod STREQUAL "Makefile")
		continue()
	endif()

	set(modenabled true)

	if(moddisable_${mod})
		set(modenabled false)
	endif()

	if(NOT OPENSSL_FOUND)
		file(READ "${modpath}" modcontent)
		string(FIND "${modcontent}" "REQUIRESSL" requiressl)
		if(NOT requiressl EQUAL "-1")
			set(modenabled false)
		endif()
	endif()

	if(modenabled)
		if(modtype STREQUAL "cpp")
			add_cxx_module("${mod}" "${modpath}")
		elseif(modtype STREQUAL "pm")
			add_perl_module("${mod}" "${modpath}")
		elseif(modtype STREQUAL "py")
			add_python_module("${mod}" "${modpath}")
		else()
			continue()
		endif()
	endif()

	list(APPEND actual_modules "${modpath}")
endforeach()

if(HAVE_I18N)
	add_subdirectory(po)
endif()

install(DIRECTORY data/
	DESTINATION "${CMAKE_INSTALL_DATADIR}/znc/modules")

=== src/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

if(CMAKE_VERSION VERSION_LESS 3.2)
	# Since 3.2 it does this automatically from BYPRODUCTS
	set_source_files_properties("versionc.cpp" PROPERTIES GENERATED true)
endif()

set(znc_cpp "ZNCString.cpp" "znc.cpp" "IRCNetwork.cpp" "Translation.cpp"
	"IRCSock.cpp" "Client.cpp" "Chan.cpp" "Nick.cpp" "Server.cpp"
	"Modules.cpp" "MD5.cpp" "Buffer.cpp" "Utils.cpp" "FileUtils.cpp"
	"HTTPSock.cpp" "Template.cpp" "ClientCommand.cpp" "Socket.cpp"
	"SHA256.cpp" "WebModules.cpp" "Listener.cpp" "Config.cpp" "ZNCDebug.cpp"
	"Threads.cpp" "Query.cpp" "SSLVerifyHost.cpp" "Message.cpp" "User.cpp")
znc_add_library(znclib ${lib_type} ${znc_cpp} "Csocket.cpp" "versionc.cpp")
znc_add_executable(znc "main.cpp")
target_link_libraries(znc PRIVATE znclib)

copy_csocket(copy_csocket_cc
	"${PROJECT_SOURCE_DIR}/third_party/Csocket/Csocket.cc"
	"${CMAKE_CURRENT_BINARY_DIR}/Csocket.cpp")

# make-tarball.sh can create this file, it'll contain -nightly-20151221-71eaf94
if(EXISTS "${PROJECT_SOURCE_DIR}/.nightly")
	file(READ "${PROJECT_SOURCE_DIR}/.nightly" nightly)
	string(STRIP "${nightly}" nightly)
else()
	set(nightly "")
endif()

add_custom_target(version
	COMMAND "${CMAKE_COMMAND}"
	-D "nightly=${nightly}"
	-D "alpha_version=${alpha_version}"
	-D "append_git_version=${append_git_version}"
	-D "gitcmd=${GIT_EXECUTABLE}"
	-D "srcdir=${PROJECT_SOURCE_DIR}"
	-D "srcfile=${CMAKE_CURRENT_SOURCE_DIR}/version.cpp.in"
	-D "destfile=${CMAKE_CURRENT_BINARY_DIR}/versionc.cpp"
	-P "${PROJECT_SOURCE_DIR}/cmake/gen_version.cmake"
	# This is versionc to avoid possible conflict with version.cpp generated
	# by make-tarball.sh
	BYPRODUCTS "versionc.cpp"
	WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
	VERBATIM)

add_dependencies(znclib copy_csocket_h copy_csocket_cc version)

set(znc_include_dirs
	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
	"$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>"
	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}>")
target_link_libraries(znclib ${CMAKE_DL_LIBS} Threads::Threads)
if(OPENSSL_FOUND)
	target_link_libraries(znclib ${OPENSSL_LIBRARIES})
	list(APPEND znc_include_dirs "${OPENSSL_INCLUDE_DIR}")
endif()
if(ZLIB_FOUND)
	target_link_libraries(znclib ${ZLIB_LIBRARIES})
	list(APPEND znc_include_dirs ${ZLIB_INCLUDE_DIRS})
endif()
if(ICU_FOUND)
	target_link_libraries(znclib ${ICU_LDFLAGS})
	list(APPEND znc_include_dirs ${ICU_INCLUDE_DIRS})
endif()
if(Boost_FOUND)
	target_link_libraries(znclib ${Boost_LIBRARIES})
	list(APPEND znc_include_dirs ${Boost_INCLUDE_DIRS})
endif()
target_include_directories(znc PUBLIC ${znc_include_dirs})
target_include_directories(znclib PUBLIC ${znc_include_dirs})

set_target_properties(znclib ${znc_link} PROPERTIES
	COMPILE_OPTIONS "-include;znc/zncconfig.h"
	INTERFACE_COMPILE_OPTIONS "-include;znc/zncconfig.h"
	POSITION_INDEPENDENT_CODE true
	INTERFACE_POSITION_INDEPENDENT_CODE true
	# This option is relevant only on non-cygwin
	ENABLE_EXPORTS true)
# The following options are relevant only on cygwin
set_target_properties(znclib PROPERTIES
	OUTPUT_NAME "znc"
	SOVERSION "${ZNC_VERSION}")

# CMake started supporting metafeature cxx_std_11 only in 3.8
set(required_cxx11_features
	cxx_range_for cxx_nullptr cxx_override
	cxx_lambdas cxx_auto_type)
target_compile_features(znc PUBLIC ${required_cxx11_features})
target_compile_features(znclib PUBLIC ${required_cxx11_features})

add_library(ZNC INTERFACE)
target_link_libraries(ZNC INTERFACE ${znc_link})
target_compile_definitions(ZNC INTERFACE "znc_export_lib_EXPORTS")

if(HAVE_I18N)
	add_subdirectory(po)
endif()


install(TARGETS znc ${install_lib}
	EXPORT znc_internal
	RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	# this one is libznc.dll.a for cygwin
	ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(TARGETS ZNC EXPORT znc_public)
install(EXPORT znc_internal
	DESTINATION "${CMAKE_INSTALL_DATADIR}/znc/cmake"
	NAMESPACE ZNC::internal::)
install(EXPORT znc_public
	DESTINATION "${CMAKE_INSTALL_DATADIR}/znc/cmake"
	NAMESPACE ZNC::)

=== test/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# No CTest here, and no "make test" either:
# http://public.kitware.com/Bug/view.php?id=8438
# http://public.kitware.com/Bug/view.php?id=8774

include(ExternalProject)
include(FindPackageMessage)

# There is FindGTest.cmake, but it doesn't find gmock
#message(STATUS "Looking for GTest/GMock")
find_path(GTEST_ROOT src/gtest-all.cc
	HINTS ENV GTEST_ROOT
	PATHS "${PROJECT_SOURCE_DIR}/third_party/googletest/googletest")
find_path(GMOCK_ROOT src/gmock-all.cc
	HINTS ENV GMOCK_ROOT
	PATHS "${PROJECT_SOURCE_DIR}/third_party/googletest/googlemock")

set(gtest_error_msg "not found, testing will be disabled.")
set(gtest_error_msg "${gtest_error_msg} You can set environment variables")
set(gtest_error_msg "${gtest_error_msg} GTEST_ROOT and GMOCK_ROOT")
if(GTEST_ROOT)
	find_package_message(gtest "Found GoogleTest: ${GTEST_ROOT}"
		"${GTEST_ROOT}")
else()
	find_package_message(gtest "GoogleTest ${gtest_error_msg}" "${GTEST_ROOT}")
	return()
endif()
if(GMOCK_ROOT)
	find_package_message(gmock "Found GoogleMock: ${GMOCK_ROOT}"
		"${GMOCK_ROOT}")
else()
	find_package_message(gmock "GoogleMock ${gtest_error_msg}" "${GMOCK_ROOT}")
	return()
endif()

# Force the simple internal regex engine to get consistent behavior on all
# platforms. See
# https://code.google.com/p/chromium/issues/detail?id=317224 for more details.
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS
	"GTEST_HAS_POSIX_RE=0")

add_executable(unittest_bin EXCLUDE_FROM_ALL
	"${GMOCK_ROOT}/src/gmock_main.cc"
	"${GTEST_ROOT}/src/gtest-all.cc"
	"${GMOCK_ROOT}/src/gmock-all.cc"
	"ThreadTest.cpp" "NickTest.cpp" "ClientTest.cpp" "NetworkTest.cpp"
	"MessageTest.cpp" "ModulesTest.cpp" "IRCSockTest.cpp" "QueryTest.cpp"
	"StringTest.cpp" "ConfigTest.cpp" "BufferTest.cpp" "UtilsTest.cpp"
	"UserTest.cpp")
target_link_libraries(unittest_bin PRIVATE znclib)
target_include_directories(unittest_bin PRIVATE
	"${GTEST_ROOT}" "${GTEST_ROOT}/include"
	"${GMOCK_ROOT}" "${GMOCK_ROOT}/include")
add_custom_target(unittest COMMAND unittest_bin)

# Use different compiler flags, because Qt fails with sanitizers,
# and we don't need sanitizers to test the test itself anyway.
externalproject_add(inttest_bin
	EXCLUDE_FROM_ALL true
	BUILD_ALWAYS true
	SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/integration"
	BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/integration"
	INSTALL_COMMAND ""
	CMAKE_CACHE_ARGS
	# Note the space in the end: protect from CXXFLAGS env var (see comment
	# above), but still support custom flags
	"-DCMAKE_CXX_FLAGS:string=${INTEGRATION_TEST_CXX_FLAGS} "
	# Build integration test with the correct compiler.
	# https://bugs.gentoo.org/699258
	# CMAKE_CXX_COMPILER is passed for the case if the main cmake was called
	# with -DCMAKE_CXX_COMPILER but without -DCMAKE_TOOLCHAIN_FILE.
	"-DCMAKE_TOOLCHAIN_FILE:path=${CMAKE_TOOLCHAIN_FILE}"
	"-DCMAKE_CXX_COMPILER:string=${CMAKE_CXX_COMPILER}"

	"-DGTEST_ROOT:path=${GTEST_ROOT}"
	"-DGMOCK_ROOT:path=${GMOCK_ROOT}"
	"-DZNC_BIN_DIR:path=${CMAKE_INSTALL_FULL_BINDIR}"
	"-DQt5_HINTS:path=${brew_qt5}")
add_custom_target(inttest COMMAND
	#   MAKEFLAGS:
	# Prevent a warning from test of znc-buildmod, when inner make
	# discovers that there is an outer make and tries to use it:
	# gmake[4]: warning: jobserver unavailable: using -j1.  Add '+' to parent make rule.
	# This option doesn't affect ninja, which doesn't show that warning anyway.
	#
	#   CXX: 
	# znc-buildmod should use the correct compiler.
	# https://bugs.gentoo.org/699258 is an example of how it can go wrong.
	${CMAKE_COMMAND} -E env MAKEFLAGS= CXX=${CMAKE_CXX_COMPILER}
	"${CMAKE_CURRENT_BINARY_DIR}/integration/inttest")
add_dependencies(inttest inttest_bin)

=== zz_msg/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# This is implementation detail of CMake, but this install() runs last.
# Details are at https://cmake.org/pipermail/cmake/2011-July/045615.html

install(CODE "message(\"
******************************************************************
 ZNC was successfully installed.
 You can use '${CMAKE_INSTALL_FULL_BINDIR}/znc --makeconf'
 to generate a config file.

 If you need help with using ZNC, please visit our wiki at:
   http://znc.in\")")

=== cmake/cxx11check/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.0)
project(cxx11check LANGUAGES CXX)
set(CMAKE_VERBOSE_MAKEFILE true)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED true)
add_executable(main main.cpp)

=== cmake/perl_check/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.0)
project(perl_check LANGUAGES CXX)
set(CMAKE_VERBOSE_MAKEFILE true)

if(APPLE)
	set(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS
		"${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
endif()

add_library(main MODULE main.cpp)
target_include_directories(main PRIVATE ${PERL_INCLUDE_DIRS})
target_compile_options(main PRIVATE "${PERL_CFLAGS}")
target_link_libraries(main PRIVATE ${PERL_LIBRARIES})
set_target_properties(main PROPERTIES LINK_FLAGS "${PERL_LDFLAGS}")

=== include/znc/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

copy_csocket(copy_csocket_h
	"${PROJECT_SOURCE_DIR}/third_party/Csocket/Csocket.h"
	"${CMAKE_CURRENT_BINARY_DIR}/Csocket.h")

# __attribute__((__visibility__("default")) macro comes from
# generate_export_header(), which wants a library.
# we don't really care which library is that.
# Macro defined by this generated header is used in Modules.h
# Name of this pseudolibrary matches the define passed to modules.
add_library(znc_export_lib SHARED IMPORTED)
include(GenerateExportHeader)
generate_export_header(znc_export_lib)

install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/" "${CMAKE_CURRENT_BINARY_DIR}/"
	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/znc"
	FILES_MATCHING
	PATTERN "*.h"
	PATTERN CMakeFiles EXCLUDE)

=== modules/modperl/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# TODO: consider switching to swig_add_library() after bumping CMake
# requirements to 3.8, when that command started using IMPLICIT_DEPENDS

set(modinclude_modperl PUBLIC ${PERL_INCLUDE_DIRS}
	"${CMAKE_CURRENT_BINARY_DIR}/.." PARENT_SCOPE)
set(modcompile_modperl PUBLIC "${PERL_CFLAGS}" PARENT_SCOPE)
set(modlink_modperl PUBLIC ${PERL_LIBRARIES} PARENT_SCOPE)
set(modprop_modperl LINK_FLAGS "${PERL_LDFLAGS}" PARENT_SCOPE)
set(moddef_modperl PUBLIC "SWIG_TYPE_TABLE=znc" PARENT_SCOPE)
set(moddepend_modperl modperl_functions modperl_swigruntime PARENT_SCOPE)

if(APPLE)
	set(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS
		"${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
endif()

if(SWIG_FOUND)
	add_custom_command(
		OUTPUT perlfunctions.cpp
		COMMAND "${PERL_EXECUTABLE}"
		"${CMAKE_CURRENT_SOURCE_DIR}/codegen.pl"
		"${CMAKE_CURRENT_SOURCE_DIR}/functions.in"
		"perlfunctions.cpp"
		VERBATIM
		DEPENDS codegen.pl functions.in)

	add_custom_command(
		OUTPUT swigperlrun.h
		COMMAND "${SWIG_EXECUTABLE}" -perl -c++ -shadow -external-runtime
		"swigperlrun.h"
		VERBATIM)

	add_custom_command(
		OUTPUT modperl_biglib.cpp ZNC.pm
		COMMAND "${SWIG_EXECUTABLE}" -perl -c++ -shadow
		"-I${PROJECT_BINARY_DIR}/include"
		"-I${PROJECT_SOURCE_DIR}/include"
		"-I${CMAKE_CURRENT_SOURCE_DIR}/.."
		"-I${CMAKE_CURRENT_SOURCE_DIR}/include"
		-DZNC_EXPORT_LIB_EXPORT
		-outdir "${CMAKE_CURRENT_BINARY_DIR}"
		-o "${CMAKE_CURRENT_BINARY_DIR}/modperl_biglib.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/modperl.i"
		DEPENDS "modperl.i" copy_csocket_h
		IMPLICIT_DEPENDS CXX "${CMAKE_CURRENT_SOURCE_DIR}/modperl.i"
		VERBATIM)
else()
	add_custom_command(
		OUTPUT swigperlrun.h ZNC.pm modperl_biglib.cpp perlfunctions.cpp
		COMMAND "${CMAKE_COMMAND}" -E tar xz
		"${CMAKE_CURRENT_SOURCE_DIR}/generated.tar.gz"
		VERBATIM)
endif()
add_custom_target(modperl_functions DEPENDS "perlfunctions.cpp")
add_custom_target(modperl_swigruntime DEPENDS "swigperlrun.h")
add_custom_target(modperl_swig DEPENDS "modperl_biglib.cpp" "ZNC.pm")

execute_process(COMMAND "${PERL_EXECUTABLE}"
	-MConfig "-eprint $Config::Config{dlext}"
	OUTPUT_VARIABLE perl_ext)

znc_add_library(modperl_lib MODULE modperl_biglib.cpp)
add_dependencies(modperl_lib modperl_swig)
target_include_directories(modperl_lib PRIVATE
	"${PROJECT_BINARY_DIR}/include"
	"${PROJECT_SOURCE_DIR}/include"
	"${CMAKE_CURRENT_BINARY_DIR}/.."
	"${CMAKE_CURRENT_SOURCE_DIR}/.."
	${PERL_INCLUDE_DIRS})
target_link_libraries(modperl_lib ${znc_link})
set_target_properties(modperl_lib PROPERTIES
	PREFIX ""
	SUFFIX ".${perl_ext}"
	OUTPUT_NAME "ZNC"
	NO_SONAME true
	LINK_FLAGS "${PERL_LDFLAGS}")
target_compile_options(modperl_lib PRIVATE "${PERL_CFLAGS}")
target_compile_definitions(modperl_lib PRIVATE "SWIG_TYPE_TABLE=znc")
if(CYGWIN)
	target_link_libraries(modperl_lib module_modperl)
endif()

install(TARGETS modperl_lib
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/znc/modperl")
install(FILES "startup.pl" "${CMAKE_CURRENT_BINARY_DIR}/ZNC.pm"
	DESTINATION "${CMAKE_INSTALL_LIBDIR}/znc/modperl")

function(add_perl_module mod modpath)
	install(FILES "${modpath}" DESTINATION "${CMAKE_INSTALL_LIBDIR}/znc")
endfunction()

# This target is used to generate tarball which doesn't depend on SWIG.
add_custom_target(modperl_dist
	COMMAND "${CMAKE_COMMAND}" -E tar cz
	"${CMAKE_CURRENT_SOURCE_DIR}/generated.tar.gz"
	"swigperlrun.h" "ZNC.pm" "modperl_biglib.cpp" "perlfunctions.cpp"
	DEPENDS swigperlrun.h ZNC.pm modperl_biglib.cpp perlfunctions.cpp
	VERBATIM)
add_dependencies(modperl_dist copy_csocket_h)

=== modules/modpython/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# TODO: consider switching to swig_add_library() after bumping CMake
# requirements to 3.8, when that command started using IMPLICIT_DEPENDS

set(modinclude_modpython PUBLIC ${Python3_INCLUDE_DIRS}
	"${CMAKE_CURRENT_BINARY_DIR}/.." PARENT_SCOPE)
set(modlink_modpython PUBLIC ${Python3_LDFLAGS} PARENT_SCOPE)
set(moddef_modpython PUBLIC "SWIG_TYPE_TABLE=znc" PARENT_SCOPE)
set(moddepend_modpython modpython_functions modpython_swigruntime PARENT_SCOPE)

if(APPLE)
	set(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS
		"${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -undefined dynamic_lookup")
endif()

if(SWIG_FOUND)
	add_custom_command(
		OUTPUT "pyfunctions.cpp"
		COMMAND "${PERL_EXECUTABLE}"
		"${CMAKE_CURRENT_SOURCE_DIR}/codegen.pl"
		"${CMAKE_CURRENT_SOURCE_DIR}/functions.in"
		"pyfunctions.cpp"
		VERBATIM
		DEPENDS codegen.pl functions.in)

	add_custom_command(
		OUTPUT "swigpyrun.h"
		COMMAND "${SWIG_EXECUTABLE}" -python -py3 -c++ -shadow -external-runtime
		"swigpyrun.h"
		VERBATIM)

	add_custom_command(
		OUTPUT "modpython_biglib.cpp" "znc_core.py"
		COMMAND "${SWIG_EXECUTABLE}" -python -py3 -c++ -shadow
		"-I${PROJECT_BINARY_DIR}/include"
		"-I${PROJECT_SOURCE_DIR}/include"
		"-I${CMAKE_CURRENT_SOURCE_DIR}/.."
		-DZNC_EXPORT_LIB_EXPORT
		-outdir "${CMAKE_CURRENT_BINARY_DIR}"
		-o "${CMAKE_CURRENT_BINARY_DIR}/modpython_biglib.cpp"
		"${CMAKE_CURRENT_SOURCE_DIR}/modpython.i"
		DEPENDS "modpython.i" copy_csocket_h
		IMPLICIT_DEPENDS CXX "${CMAKE_CURRENT_SOURCE_DIR}/modpython.i"
		VERBATIM)
else()
	add_custom_command(
		OUTPUT swigpyrun.h znc_core.py modpython_biglib.cpp pyfunctions.cpp
		COMMAND "${CMAKE_COMMAND}" -E tar xz
		"${CMAKE_CURRENT_SOURCE_DIR}/generated.tar.gz"
		VERBATIM)
endif()
add_custom_target(modpython_functions DEPENDS "pyfunctions.cpp")
add_custom_target(modpython_swigruntime DEPENDS "swigpyrun.h")
add_custom_target(modpython_swig DEPENDS "modpython_biglib.cpp" "znc_core.py")

znc_add_library(modpython_lib MODULE modpython_biglib.cpp)
add_dependencies(modpython_lib modpython_swig)
target_include_directories(modpython_lib PRIVATE
	"${PROJECT_BINARY_DIR}/include"
	"${PROJECT_SOURCE_DIR}/include"
	"${CMAKE_CURRENT_BINARY_DIR}/.."
	"${CMAKE_CURRENT_SOURCE_DIR}/.."
	${Python3_INCLUDE_DIRS})
target_link_libraries(modpython_lib ${znc_link} ${Python3_LDFLAGS})
set_target_properties(modpython_lib PROPERTIES
	PREFIX "_"
	OUTPUT_NAME "znc_core"
	NO_SONAME true)
target_compile_definitions(modpython_lib PRIVATE "SWIG_TYPE_TABLE=znc")
if(CYGWIN)
	target_link_libraries(modpython_lib module_modpython)
endif()

install(TARGETS modpython_lib
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/znc/modpython")
install(FILES "znc.py" "${CMAKE_CURRENT_BINARY_DIR}/znc_core.py"
	DESTINATION "${CMAKE_INSTALL_LIBDIR}/znc/modpython")

function(add_python_module mod modpath)
	install(FILES "${modpath}" DESTINATION "${CMAKE_INSTALL_LIBDIR}/znc")
endfunction()

# This target is used to generate tarball which doesn't depend on SWIG.
add_custom_target(modpython_dist
	COMMAND "${CMAKE_COMMAND}" -E tar cz
	"${CMAKE_CURRENT_SOURCE_DIR}/generated.tar.gz"
	"swigpyrun.h" "znc_core.py" "modpython_biglib.cpp" "pyfunctions.cpp"
	DEPENDS swigpyrun.h znc_core.py modpython_biglib.cpp pyfunctions.cpp
	VERBATIM)
add_dependencies(modpython_dist copy_csocket_h)

=== modules/modtcl/CMakeLists.txt ===
#
# Copyright (C) 2004-2020 ZNC, see the NOTICE file for details.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

set(modinclude_modtcl PRIVATE ${TCL_INCLUDE_PATH} PARENT_SCOPE)
set(modlink_modtcl PRIVATE ${TCL_LIBRARY} PARENT_SCOPE)

install(FILES "modtcl.tcl" "binds.tcl"
	DESTINATION "${CMAKE_INSTALL_DATADIR}/znc/modtcl")

=== debian/changelog ===
znc (1.8.2-4) unstable; urgency=medium

  * Bump Standards-Version to 4.6.2.
  * Acknowledge NMU from Andreas Beckmann.
  * Update debian/copyright.
  * Adjust lintian overrides.
  * Improve znc service file security.
    Closes: #1033812

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 12 Dec 2023 16:20:12 +0100

znc (1.8.2-3.1) unstable; urgency=medium

  * Non-maintainer upload with maintainer approval.
  * znc: Add dependency on adduser.  (Closes: #1035284)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 May 2023 19:54:58 +0200

znc (1.8.2-3) unstable; urgency=medium

  * Bump Standards-Version to 4.6.1.
  * Update debian/copyright.
  * Adjust lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 14 Sep 2022 14:38:15 +0200

znc (1.8.2-2) unstable; urgency=medium

  * Adjust lintian overrides.
  * Bump Standards-Version to 4.5.1.
  * Update debian/watch file standard to version 4.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 19 Nov 2020 15:00:48 +0100

znc (1.8.2-1) unstable; urgency=medium

  * New upstream release.
  * Adjust unused lintian overrides.

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 09 Sep 2020 10:54:03 +0200

=== debian/control ===
Source: znc
Section: net
Priority: optional
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Uploaders: Mattia Rizzolo <mattia@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-python,
 cmake,
 google-mock,
 googletest,
 pkg-config,
 swig,
 libboost-all-dev,
 libcurl4-openssl-dev,
 libssl-dev,
 libperl-dev,
 libicu-dev,
 libsasl2-dev,
 zlib1g-dev,
 tcl-dev,
 python3-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.znc.in/

Package: znc
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 adduser,
 openssl
Recommends: znc-tcl,
 znc-perl,
 znc-python
Conflicts: znc-webadmin,
 znc-extra
Breaks: znc-extra (<< ${binary:Version})
Replaces: znc-webadmin,
 znc-extra
Description: advanced modular IRC bouncer
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.

Package: znc-dev
Architecture: any
Depends: ${misc:Depends},
 ${python3:Depends},
 znc (>= ${binary:Version}),
 cmake,
 libicu-dev,
 libssl-dev,
 pkg-config,
 tcl-dev,
 python3-dev
Recommends: g++
Description: advanced modular IRC bouncer (development headers)
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.
 .
 This package contains the znc development headers for developing modules.

Package: znc-perl
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 znc (= ${binary:Version})
Description: advanced modular IRC bouncer (Perl extension)
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.
 .
 This package contains the znc Perl extension.

Package: znc-python
Architecture: any
Depends: ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
 znc (= ${binary:Version})
Description: advanced modular IRC bouncer (Python extension)
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.
 .
 This package contains the znc Python extension.

Package: znc-tcl
Section: interpreters
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 znc (= ${binary:Version})
Description: advanced modular IRC bouncer (Tcl extension)
 znc is an IRC proxy. It runs as a daemon and connects to IRC server,
 then allows you to connect from a workstation and work as the user that
 is logged in to the IRC server. After you disconnect, it maintains the
 connection to the server. It acts like any normal IRC server, so you can
 use any IRC client to connect to it.
 .
 Some of its features include support for multiple users, multiple clients,
 and multiple IRC servers; playback buffers to catch up with what happened
 while you were detached, SSL encryption, DCC proxying, and a plugin
 interface with many plugins supporting other features.
 .
 This package contains the znc Tcl extension.

Package: znc-push
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 znc (= ${binVer}),
Enhances: znc
Homepage: https://github.com/jreese/znc-push
Description: znc plugin to send push notification to various services
 ZNC Push is a third party ZNC module that will send notifications to
 multiple push  notification services, or SMS for any private message or
 channel highlight that matches a configurable set of conditions.
 .
 ZNC Push current supports the following services:
  * Boxcar
  * Boxcar 2
  * Pushover
  * Pushsafer
  * Prowl
  * Supertoasty
  * PushBullet
  * Airgram
  * Faast
  * Nexmo
  * Pushalot
  * Pushjet
  * Telegram
  * Custom URL GET requests
 .
 For more information about ZNC, see the znc package.

Package: znc-backlog
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 znc (= ${binVer}),
Enhances: znc
Homepage: https://github.com/FruitieX/znc-backlog
Description: module for requesting backlog from znc bouncer
 znc-backlog is a third party ZNC module that makes it easy to request backlog.
 Its intended use is for when you have just launched your IRC client and gotten
 a few lines of backlog sent to you, but want to read more. Instead of having
 to deal with shelling into the box where you run ZNC and manually sifting
 through the logs, you can issue a short command in your IRC client to request
 any amount of the most recent lines of log.
 .
 For more information about ZNC, see the znc package.
